"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Optional = (function () {
    function Optional() {
    }
    Object.defineProperty(Optional.prototype, "isEmpty", {
        get: function () {
            return !this.isPresent;
        },
        enumerable: true,
        configurable: true
    });
    Optional.ofNullable = function (nullable) {
        if (nullable !== null && nullable !== undefined)
            return new PresentOptional(nullable);
        else
            return new EmptyOptional();
    };
    Optional.ofNonNull = function (payload) {
        if (payload !== null && payload !== undefined)
            return new PresentOptional(payload);
        else
            throw new TypeError("The passed value was null or undefined.");
    };
    Optional.empty = function () {
        return new EmptyOptional();
    };
    return Optional;
}());
exports.default = Optional;
var PresentOptional = (function (_super) {
    __extends(PresentOptional, _super);
    function PresentOptional(value) {
        var _this = _super.call(this) || this;
        _this.payload = value;
        return _this;
    }
    Object.defineProperty(PresentOptional.prototype, "isPresent", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    PresentOptional.prototype.get = function () {
        return this.payload;
    };
    PresentOptional.prototype.ifPresent = function (consumer) {
        consumer(this.payload);
    };
    PresentOptional.prototype.ifPresentOrElse = function (consumer, emptyAction) {
        consumer(this.payload);
    };
    PresentOptional.prototype.filter = function (predicate) {
        return (predicate(this.payload)) ? this : Optional.empty();
    };
    PresentOptional.prototype.map = function (mapper) {
        return Optional.ofNullable(mapper(this.payload));
    };
    PresentOptional.prototype.flatMap = function (mapper) {
        return mapper(this.payload);
    };
    PresentOptional.prototype.or = function (supplier) {
        return this;
    };
    PresentOptional.prototype.orElse = function (another) {
        return this.payload;
    };
    PresentOptional.prototype.orElseGet = function (another) {
        return this.payload;
    };
    PresentOptional.prototype.orElseThrow = function (exception) {
        return this.payload;
    };
    return PresentOptional;
}(Optional));
var EmptyOptional = (function (_super) {
    __extends(EmptyOptional, _super);
    function EmptyOptional() {
        return _super.call(this) || this;
    }
    Object.defineProperty(EmptyOptional.prototype, "isPresent", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    EmptyOptional.prototype.get = function () {
        throw new TypeError("The optional is not present.");
    };
    EmptyOptional.prototype.ifPresent = function (consumer) {
    };
    EmptyOptional.prototype.ifPresentOrElse = function (consumer, emptyAction) {
        emptyAction();
    };
    EmptyOptional.prototype.filter = function (predicate) {
        return this;
    };
    EmptyOptional.prototype.map = function (mapper) {
        return Optional.empty();
    };
    EmptyOptional.prototype.flatMap = function (mapper) {
        return Optional.empty();
    };
    EmptyOptional.prototype.or = function (supplier) {
        return supplier();
    };
    EmptyOptional.prototype.orElse = function (another) {
        return another;
    };
    EmptyOptional.prototype.orElseGet = function (another) {
        return this.orElse(another());
    };
    EmptyOptional.prototype.orElseThrow = function (exception) {
        throw exception();
    };
    return EmptyOptional;
}(Optional));
//# sourceMappingURL=index.js.map